<%@ page language="java" contentType="text/html; charset=UTF-8"
         pageEncoding="UTF-8" %>
<%@taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <title>Insert title here</title>
    <%@include file="/views/common.jsp" %>
</head>
<body>
<style>
    #z4_craft .layui-form-select .layui-edge {
        right: 20px;
    }
</style>
<div class="big_box">
    <div class="left_div">
        <h1 class="h1">金属微章</h1> <span style="color:red;font-weight:700;"></span>
        <hr>
        <form class="layui-form">
            <input type="hidden" name="proTypeValue" id="proTypeValue" class="layui-input" value="金属微章"/>
            <p>
                材质
            </p>
            <div class="layui-form-item">
                <select name="kind" class="select" lay-search lay-filter="kind">
                    <option value="1">铁</option>
                    <option value="2">锌合金</option>
                </select>
            </div>
            <p>
                尺寸(CM/厘米) <span style="font-size: 14px; color: red">输入格式: 长 * 宽</span>
            </p>
            <div class="layui-form-item" id="ui_size">
                <input type="text" name="size" id="size" value="3*3" class="layui-input" autocomplete="off">
            </div>

            <div class="layui-form-item">
                <div class="layui-form-item layui-input-inline">
                    <p>
                        数量(个)
                    </p>
                    <div class="layui-form-item" style="width: 200px">
                        <select id="count_select" lay-filter="count_select" class="select">
                            <option value="50">50</option>
                            <option value="100">100</option>
                            <option value="200">200</option>
                            <option value="500">500</option>
                            <option value="1000">1000</option>
                            <option value="2000">2000</option>
                            <option value="3000">3000</option>
                            <option value="5000">5000</option>
                            <option value="10000">10000</option>
                        </select>
                    </div>
                </div>
                <div class=" layui-input-inline">
                    <p>
                        自定义数量
                    </p>
                    <div class="layui-form-item" style="width: 500px">
                        <input type="text" name="count" id="count" value="50" class="layui-input">
                    </div>
                </div>
            </div>
            <p>
                款数
            </p>
            <div class="layui-form-item">
                <input type="text" placeholder="请输入整数" autocomplete="off" name="number" id="number" value="1"
                       class="layui-input" lay-verify="number">
            </div>
            <p>
                客户旺旺
            </p>
            <div class="layui-form-item">
                <input type="text" placeholder="请输入客户旺旺号" autocomplete="off" name="wangwang" id="wangwang"
                       class="layui-input">
            </div>
            <p>
                工艺<span style="font-size: 14px; color: red">PET印刷只能做固定3*3cm尺寸</span>
            </p>
            <div class="layui-form-item" id='z4_craft'>
                <div class="layui-input-block">
                    画面工艺：
                    <input type="checkbox" name="craft" lay-filter="ui_craft" value="UV印刷" title="UV印刷">
                    <span>
                        <input type="checkbox" name="craft" lay-filter="ui_craft" value="PET印刷" title="PET印刷" checked>
                    </span>
                </div>
                <div class="layui-input-block">
                    底托颜色：
                    <input type="checkbox" name="craft" lay-filter="ui_craft" value="金色" title="金色" checked>
                    <input type="checkbox" name="craft" lay-filter="ui_craft" value="银色" title="银色">
                    <span style="display: none">
                        <input type="checkbox" name="craft" lay-filter="ui_craft" value="黑色" title="黑色">
                    </span>
                </div>
                <div class="layui-input-block">
                    配件：
                    <input type="checkbox" class="peijian" name="craft" lay-filter="peijian" value="别针"
                           title="别针" checked>
                    <input type="checkbox" class="peijian" name="craft" lay-filter="peijian" value="蝴蝶扣"
                           title="蝴蝶扣">
                    <input type="checkbox" class="peijian" name="craft" lay-filter="peijian" value="磁铁"
                           title="磁铁">
                </div>
            </div>
            <hr>
            <div class="layui-form-item">
                <button class="layui-btn" lay-submit="" lay-filter="acount_btn">计算</button>
                <button type="reset" class="layui-btn layui-btn-primary">重置</button>
            </div>
            <h2>计算结果-
                <button type="button" class="layui-btn layui-btn-primary layui-btn-sm copyResult"
                        onclick="copyResult()">点击复制
                </button>
            </h2>
            <div>
                <textarea rows="11" cols="75" id="span_result" readonly="readonly"></textarea>
                <%@include file="../acountExpressFee.jsp" %>
            </div>
            <div>
                <table class="layui-hide" id="priceTable" lay-filter="priceTable"></table>
            </div>
        </form>
    </div>
    <div class="right_div" style="margin-left:50px;">
        <div class="layui-carousel" id="test1">
            <div carousel-item id="carousel"></div>
            <br>
            <div id="remark" style="font-size:20px;color:red"></div>
        </div>
    </div>
</div>
</body>
<%@include file="/views/copyResult.jsp" %>
<script>
    function changeRemark() {
        let craft_list = [];
        craft_list.push($("select[name='craft'] option:selected").val());
        $("input[name='craft']:checked").each(function () {
                if (!$(this).is(':disabled')) {
                    craft_list.push($(this).val());
                }
            }
        );
        let remark = " ";
        if (craft_list.includes("PET印刷")) {
            remark = "预计发货时间：<br>发货地：浙江    <br>快递：中通  顺丰特快 <br>100个以内隔天发货<br>100-500个2天左右发货<br>500-1000个3天左右发货<br>1000-3000个4天左右发货";
        }
        if (craft_list.includes("UV印刷")) {
            remark = "预计发货时间：<br>发货地：浙江    <br>快递：中通  顺丰特快 <br>10-12天发货";
        }
        $("#remark").empty();
        $("#remark").append(remark);
    }

    layui.use(['table', 'form', 'carousel'], function () {
        var form = layui.form; //只有执行了这一步，部分表单元素才会自动修饰成功
        var carousel = layui.carousel;
        var table = layui.table;


        //建造实例
        ins = carousel.render({});

        const carft_list1 = ["金色", "银色", "黑色"];

        const carft_list2 = ["别针", "蝴蝶扣", "磁铁"];

        const carft_list3 = ["UV印刷", "PET印刷"];
        getImages()

        function getImages() {
            // 清空轮播图
            let html = " ";
            let remark = " ";
            $("#carousel").empty();
            $("#remark").empty();
            $(".ui_feb").show();
            $(".ui_feb select").attr("disabled", false);
            let params = {
                proTypeValue: $("#proTypeValue").val(),
                kindValue: $('input[name="kindValue"]').val()
            }
            if ($("input[name='craft'][value='UV印刷']:checked").length > 0) {
                params.craftValue = "UV";
            }
            $.ajax({
                url: "${pageContext.request.contextPath}/getImgs",
                type: "GET",
                data: params,
                success: function (result) {
                    for (let i = 0; i < result.length; i++) {
                        // 只留一个remark
                        remark = "";
                        html += '<div><img style="width:100%;height: 100%;object-fit: contain" src="' + result[i].imgUrl + '"></div>';
                        remark = '<div><span>' + result[0].remark + '<span/></div>';
                    }
                    $("#carousel").append(html);
                    // 如果没有说明，就不显示null
                    if (remark.indexOf("null") < 0) {
                        $("#remark").append(remark);
                    }
                    // 如果没有轮播图就隐藏
                    if (result.length == 0) {
                        document.getElementById("test1").style.display = "none";   //隐藏
                    } else {
                        document.getElementById("test1").style.display = "block";   //显示
                        ins.reload({
                            elem: '#test1',
                            width: result[0].imgWidth,  //设置容器宽度
                            height: result[0].imgHeight
                        });
                    }
                }
            });
        }

        form.on('select(kind)', function (val) {
            $("input[name='craft'][value='UV印刷']").prop("checked", true);
            $("input[name='craft'][value='PET印刷']").parent().show();
            $("input[name='craft'][value='PET印刷']").prop("disabled", false);
            $("input[name='craft'][value='PET印刷']").prop("checked", false);
            if (val.value == 2) {
                $("input[name='craft'][value='PET印刷']").parent().hide();
                $("input[name='craft'][value='PET印刷']").prop("disabled", true);
            }
            form.render();
            getImages()
            // changeRemark()
        })
        form.on("select(count_select)", function (val) {
            $("#count").val(val.value);
        })

        form.on('checkbox(ui_craft)', function (data) {
            let craft_list = [];
            craft_list.push($("select[name='craft'] option:selected").val());
            $("input[name='craft']:checked").each(function () {
                    if (!$(this).is(':disabled')) {
                        craft_list.push($(this).val());
                    }
                }
            );


            const carft1 = carft_list1.filter(craft => craft_list.includes(craft));
            if (carft1.length > 1) {
                $(data.elem).prop("checked", false);
                layer.msg("底托颜色不能同时选择", {offset: ['300px', '300px']}, function () {
                });
                form.render();
                return false;
            }
            const carft3 = carft_list3.filter(craft => craft_list.includes(craft));
            if (carft3.length > 1) {
                $(data.elem).prop("checked", false);
                layer.msg("画面工艺不能同时选择", {offset: ['300px', '300px']}, function () {
                });
                form.render();
                return false;
            }
            if (data.value == "UV印刷") {

                $("input[name='craft'][value='黑色']").parent().show();
                $("input[name='craft'][value='黑色']").prop("disabled", false);
            }
            if (data.value == "PET印刷") {
                $("input[name='craft'][value='金色']").prop("checked", true);
                $("input[name='craft'][value='银色']").prop("checked", false);
                $("input[name='craft'][value='黑色']").parent().hide();
                $("input[name='craft'][value='黑色']").prop("disabled", true);

                $("input[name='craft'][value='黑色']").prop("checked", false);
            }
            if (craft_list.includes("PET印刷") > 0) {
                $("#size").val("3*3")
            }
            getImages();
            form.render();
            // changeRemark()
        })
        form.on('checkbox(peijian)', function (data) {
            let craft_list = [];
            $(".peijian:checked").each(function () {
                    if (!$(this).is(':disabled')) {
                        craft_list.push($(this).val());
                    }
                }
            );
            const carft2 = carft_list2.filter(craft => craft_list.includes(craft));
            if (carft2.length > 1) {
                $(data.elem).next().attr("class", "layui-unselect layui-form-checkbox");
                $(data.elem).prop("checked", false);
                layer.msg('配件只能选择一种！', {offset: ['300px', '300px']}, {icon: 5});
                form.render();
                return false;
            }

        })

        // 点击计算，计算价格
        form.on('submit(acount_btn)', function (data) {
            var number = $("#number").val();
            var size = $("#size").val();
            var count = $("#count").val();
            var kind = $("select[name='kind'] option:selected").text();
            var craft = [];

            $("input:checkbox[name='craft']:checked").each(function (i) {
                // 没有被禁用的工艺加到arr中
                if (!$(this).is(':disabled')) {
                    craft.push($(this).val());
                }
            });
            if ((size.split("*")[0] > 9 || size.split("*")[1] > 9)) {
                layer.msg('最大尺寸9*9cm！', {offset: ['300px', '300px']}, function () {
                });
                return false;
            }
            if ((size.split("*")[0] < 1 || size.split("*")[1] < 1)) {
                layer.msg('最小尺寸1*1cm！', {offset: ['300px', '300px']}, function () {
                });
                return false;
            }
            const carft1 = carft_list1.filter(item => craft.includes(item));
            if (carft1.length == 0) {
                layer.msg("请选择底托颜色", {offset: ['300px', '300px']}, function () {
                });
                return false;
            }
            const carft2 = carft_list2.filter(item => craft.includes(item));
            if (carft2.length == 0) {
                layer.msg("请选择配件", {offset: ['300px', '300px']}, function () {
                });
                return false;
            }
            const carft3 = carft_list3.filter(item => craft.includes(item));
            if (carft3.length == 0) {
                layer.msg("请选择画面", {offset: ['300px', '300px']}, function () {
                });
                return false;
            }
            if (craft.includes("PET印刷") && (size.split("*")[0] != 3 || size.split("*")[1] != 3)) {
                layer.msg("PET印刷只能做3*3尺寸", {offset: ['300px', '300px']}, function () {
                });
                return false;
            }
            $.ajax({
                url: "${path}/getThanSum",
                type: "GET",
                data: $(".big_box form").serialize(),
                success: function (result) {
                    if (result.code == 100) {
                        layer.msg(result.msg, {offset: ['300px', '300px']}, function () {
                        });
                        return false;
                    }
                    var data = result.data.proList;

                    var span_result = '金属徽章 - ' + kind + ' - ' + size + ' CM (同款内容)\n';

                    span_result += `工艺：` + craft.join(",") + '\n';

                    if (number > 1) {
                        for (let i = 0; i < data.length; i++) {
                            span_result += number + '款 各' + data[i].count + "个，共" + data[i].price + "元" + '\n'
                            data[i].number = number;
                        }
                    } else {
                        for (let i = 0; i < data.length; i++) {
                            span_result += number + '款 ' + data[i].count + "个，共" + data[i].price + "元" + '\n'
                            data[i].number = number;
                        }
                    }

                    span_result += '包邮，免费设计呢~（偏远地区需补邮费）'
                    $("#span_result").val(span_result);

                    //计算完自动复制文本
                    var e = document.getElementById("span_result");//对象是content
                    if (e.value != "") {
                        e.select();//选择对象
                        document.execCommand("Copy");//执行浏览器复制命令
                    }

                    //生成表格
                    table.render({
                        elem: '#priceTable',
                        even: true, //隔行变色
                        data: data, // 赋值已知数据
                        width: 500,
                        cols: [[
                            {
                                field: 'number',
                                width: '12%',
                                align: "center",
                                title: '款数'
                            }, {
                                field: 'count',
                                width: '16%',
                                align: "center",
                                title: '数量'
                            }, {
                                field: 'price',
                                width: '16%',
                                align: "center",
                                title: '报价'
                            }, {
                                field: 'wangwang',
                                align: "center",
                                width: '16%',
                                title: '折扣价'
                            }, {
                                field: 'wangwang',
                                align: "center",
                                width: '19%',
                                title: '跳楼价'
                            }, {
                                field: 'weight',
                                width: '21%',
                                align: "center",
                                title: '重量（kg）'
                            }
                        ]],
                        done: function () {
                        }
                    });
                }
            });
            return false;
        });
    });
</script>
</html>